; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

      include rband.inc        ; local includes for this file

.code

start:

; 

    ; ------------------
    ; set global values
    ; ------------------
      mov hInstance,   FUNC(GetModuleHandle, NULL)
      mov CommandLine, FUNC(GetCommandLine)
      mov hIcon,       FUNC(LoadIcon,hInstance,500)
      mov hCursor,     FUNC(LoadCursor,NULL,IDC_ARROW)
      mov sWid,        FUNC(GetSystemMetrics,SM_CXSCREEN)
      mov sHgt,        FUNC(GetSystemMetrics,SM_CYSCREEN)

      call Main

      invoke ExitProcess,eax

; 

Main proc

    LOCAL Wwd:DWORD,Wht:DWORD,Wtx:DWORD,Wty:DWORD

    STRING szClassName,"Prostart_Class"

  ; --------------------------------------------
  ; register class name for CreateWindowEx call
  ; --------------------------------------------
    invoke RegisterWinClass,ADDR WndProc,ADDR szClassName,
                       hIcon,hCursor,COLOR_BTNFACE+1

  ; -------------------------------------------------
  ; macro to autoscale window co-ordinates to screen
  ; percentages and centre window at those sizes.
  ; -------------------------------------------------
    AutoScale 75, 70

    invoke CreateWindowEx,WS_EX_LEFT,
                          ADDR szClassName,
                          ADDR szDisplayName,
                          WS_OVERLAPPEDWINDOW,
                          Wtx,Wty,Wwd,Wht,
                          NULL,NULL,
                          hInstance,NULL
    mov hWnd,eax

  ; ---------------------------
  ; macros for unchanging code
  ; ---------------------------
    DisplayMenu hWnd,600
    DisplayWindow hWnd,SW_SHOWNORMAL

    call MsgLoop
    ret

Main endp

; 

RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD,
                      Icon:DWORD, Cursor:DWORD, bColor:DWORD

    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or \
                           CS_BYTEALIGNWINDOW
    m2m wc.lpfnWndProc,    lpWndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      hInstance
    m2m wc.hbrBackground,  bColor
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  lpClassName
    m2m wc.hIcon,          Icon
    m2m wc.hCursor,        Cursor
    m2m wc.hIconSm,        Icon

    invoke RegisterClassEx, ADDR wc

    ret

RegisterWinClass endp

; 

MsgLoop proc

    LOCAL msg:MSG

    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0
      cmp eax, 0
      je ExitLoop
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage,  ADDR msg
      jmp StartLoop
    ExitLoop:

    mov eax, msg.wParam
    ret

MsgLoop endp

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
 ;     LOCAL xpos  :DWORD
 ;     LOCAL ypos  :DWORD
    LOCAL pbuf1 :DWORD
    LOCAL pbuf2 :DWORD
    LOCAL hDC   :DWORD
    LOCAL Rct    :RECT
    LOCAL buffer1[128]:BYTE  ; these are two spare buffers
    LOCAL buffer2[128]:BYTE  ; for text manipulation etc..

    Switch uMsg
      Case WM_COMMAND

        Switch wParam
        ;======== menu commands ========

          Case 1010
            invoke SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL

          Case 1900
            ShellAboutBox hWin,hIcon,\
              "About Prostart 3 Template#Windows Application",\
              "Prostart 3 Template",13,10,"Copyright  MASM32 1998-2003"

          ;====== end menu commands ======
      Endsw

      Case WM_CREATE

      Case WM_LBUTTONDOWN
        .data?
          xpos1 dd ?
          ypos1 dd ?
        .code

        movsx eax, WORD PTR [ebp+20]
        mov xpos1, eax
        movsx eax, WORD PTR [ebp+22]
        mov ypos1, eax
        mov pbuf1, ptr$(buffer1)
        fn SetWindowText,hWin,cat$(pbuf1,sstr$(xpos1)," ",sstr$(ypos1))

        m2m Rct.left, xpos1
        m2m Rct.top, ypos1
        m2m Rct.right, xpos1
        m2m Rct.bottom, ypos1

        sub Rct.left, 1
        sub Rct.top, 1
        add Rct.right, 1
        add Rct.bottom, 1

        mov hDC, rv(GetDC,hWin)
        invoke DrawFocusRect,hDC,ADDR Rct
        invoke ReleaseDC,hWin,hDC

      Case WM_MOUSEMOVE
        .if wParam == MK_LBUTTON
        .data?
          xpos2 dd ?
          ypos2 dd ?
        .code

        mov hDC, rv(GetDC,hWin)
        invoke DrawFocusRect,hDC,ADDR Rct
        invoke ReleaseDC,hWin,hDC

        movsx eax, WORD PTR [ebp+20]
        mov xpos2, eax
        movsx eax, WORD PTR [ebp+22]
        mov ypos2, eax

        push ebx
        mov eax, xpos1
        mov ebx, ypos1
        mov ecx, xpos2
        mov edx, ypos2

        .if eax < ecx && ebx < edx
          mov Rct.left, eax
          mov Rct.top, ebx
          mov Rct.right, ecx
          mov Rct.bottom, edx
        .elseif eax > ecx && ebx > edx
          mov Rct.left, ecx
          mov Rct.top, edx
          mov Rct.right, eax
          mov Rct.bottom, ebx
        .elseif eax > ecx && edx > ebx
          mov Rct.left, ecx
          mov Rct.top, ebx
          mov Rct.right, eax
          mov Rct.bottom, edx
        .elseif eax < ecx && edx < ebx
          mov Rct.left, eax
          mov Rct.top, edx
          mov Rct.right, ecx
          mov Rct.bottom, ebx
        .endif

        pop ebx

        mov pbuf1, ptr$(buffer1)
        fn SetWindowText,hWin,cat$(pbuf1,sstr$(Rct.left)," ",sstr$(Rct.top)," ",sstr$(Rct.right)," ",sstr$(Rct.bottom))

        mov hDC, rv(GetDC,hWin)
        invoke DrawFocusRect,hDC,ADDR Rct
        invoke ReleaseDC,hWin,hDC

        .endif

      Case WM_LBUTTONUP
        .data?
          xpos3 dd ?
          ypos3 dd ?
        .code

        movsx eax, WORD PTR [ebp+20]
        mov xpos3, eax
        movsx eax, WORD PTR [ebp+22]
        mov ypos3, eax
        mov pbuf1, ptr$(buffer1)

        push ebx
        mov eax, xpos1
        mov ebx, ypos1
        mov ecx, xpos3
        mov edx, ypos3

        .if eax < ecx && ebx < edx
          mov Rct.left, eax
          mov Rct.top, ebx
          mov Rct.right, ecx
          mov Rct.bottom, edx
        .elseif eax > ecx && ebx > edx
          mov Rct.left, ecx
          mov Rct.top, edx
          mov Rct.right, eax
          mov Rct.bottom, ebx
        .elseif eax > ecx && edx > ebx
          mov Rct.left, ecx
          mov Rct.top, ebx
          mov Rct.right, eax
          mov Rct.bottom, edx
        .elseif eax < ecx && edx < ebx
          mov Rct.left, eax
          mov Rct.top, edx
          mov Rct.right, ecx
          mov Rct.bottom, ebx
        .endif

        pop ebx

        mov pbuf1, ptr$(buffer1)
        fn SetWindowText,hWin,cat$(pbuf1,sstr$(Rct.left)," ",sstr$(Rct.top)," ",sstr$(Rct.right)," ",sstr$(Rct.bottom))

        mov hDC, rv(GetDC,hWin)
        invoke DrawFocusRect,hDC,ADDR Rct

        invoke Rectangle,hDC,Rct.left,Rct.top,Rct.right,Rct.bottom
        ;; invoke Ellipse,hDC,Rct.left,Rct.top,Rct.right,Rct.bottom
        invoke ReleaseDC,hWin,hDC

      Case WM_SYSCOLORCHANGE

      Case WM_SIZE

 ;       Case WM_PAINT
 ;         invoke Paint_Proc,hWin
 ;         return 0

      Case WM_CLOSE

      Case WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0

    Endsw

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; 

TopXY proc wDim:DWORD, sDim:DWORD

    shr sDim, 1      ; divide screen dimension by 2
    shr wDim, 1      ; divide window dimension by 2
    mov eax, wDim    ; copy window dimension into eax
    sub sDim, eax    ; sub half win dimension from half screen dimension

    return sDim

TopXY endp

; 

Paint_Proc proc hWin:DWORD

 ;     LOCAL hDC      :DWORD
 ;     LOCAL btn_hi   :DWORD
 ;     LOCAL btn_lo   :DWORD
 ;     LOCAL Rct      :RECT
 ;     LOCAL Ps       :PAINTSTRUCT
 ; 
 ;     LOCAL hPen      :DWORD
 ;     LOCAL hPenOld   :DWORD
 ; 
 ;     invoke BeginPaint,hWin,ADDR Ps
 ;     mov hDC, eax
 ; 
 ;   ; ----------------------------------------
 ; 
 ;     invoke CreatePen,0,6,000000FFh
 ;     mov hPen, eax
 ;   
 ;     invoke SelectObject,hDC,hPen
 ;     mov hPenOld, eax
 ; 
 ;     invoke Arc,hDC,100,100,250,190,90,90,250,90
 ; 
 ;     invoke SelectObject,hDC,hPenOld
 ;     invoke DeleteObject,hPen
 ; 
 ;   ; ----------------------------------------
 ; 
 ;     invoke EndPaint,hWin,ADDR Ps
 ; 
 ;     ret

Paint_Proc endp

; 

end start
